commit 7785160fb67033dfe9cb5510014ef20be26962b2
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu May 9 21:55:14 2024 +0530

    PS-9174 [ERROR] [MY-013183] [InnoDB] Assertion failure:ibuf0ibuf.cc:3833:ib::fatal
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#36343647 mysql/mysql-server@5d06230ae2a
    
    This is a cherry-pick of the following bug fix which is already fixed
    in 8.4 through commit#79d67.
    
    Bug#35676106  Assertion failure: ibuf0ibuf.cc:3825:ib::fatal triggered thread
    
    Description:
    ------------
     When the pages of secondary index are brought to the buffer pool
     either through the ibuf merge background thread or read through
     usual io thread, first cached entries from the change buffer are
     applied to the pages. Once the entries are applied to the page,
     they are removed from the change buffer. It may possible that the
     table is deleted or being deleted during change buffer related
     operations described in the earlier.
     In the current code we handled the situation of tablespace is deleted
     but not being deleted. Latter situation must also be handled similarly.
    
    Fix:
    ====
    - Replaced the call fil_space_get_flags() with
      fil_space_acquire_silent(). Later method refuses to acquire the
      tablespace that is being deleted.
    - Improved the doxygen of the method ibuf_restore_pos()
    
    Change-Id: Ibc5a07c705988282b8b7906d645e2a108f4ada76

diff --git a/storage/innobase/ibuf/ibuf0ibuf.cc b/storage/innobase/ibuf/ibuf0ibuf.cc
index 8cb669d9987..49db66c9967 100644
--- a/storage/innobase/ibuf/ibuf0ibuf.cc
+++ b/storage/innobase/ibuf/ibuf0ibuf.cc
@@ -4262,22 +4262,23 @@ ibuf_delete(
 	}
 }
 
-/*********************************************************************//**
-Restores insert buffer tree cursor position
-@return TRUE if the position was restored; FALSE if not */
+/** Restores insert buffer tree cursor position
+@param[in]        space_id      Tablespace id
+@param[in]        page_no       index page number where the record should belong
+@param [in]       search_tuple  search tuple for entries of page_no
+@param[in]        mode       BTR_MODIFY_LEAF or BTR_MODIFY_TREE
+@param[in,out]    pcur       persistent cursor whose position is to be restored
+@param[in, out]   mtr        mini-transaction
+@return true if the position was restored; false if not */
 static MY_ATTRIBUTE((nonnull))
 ibool
 ibuf_restore_pos(
-/*=============*/
-	ulint		space,	/*!< in: space id */
-	ulint		page_no,/*!< in: index page number where the record
-				should belong */
+	ulint space_id,
+	ulint page_no,
 	const dtuple_t*	search_tuple,
-				/*!< in: search tuple for entries of page_no */
-	ulint		mode,	/*!< in: BTR_MODIFY_LEAF or BTR_MODIFY_TREE */
-	btr_pcur_t*	pcur,	/*!< in/out: persistent cursor whose
-				position is to be restored */
-	mtr_t*		mtr)	/*!< in/out: mini-transaction */
+	ulint mode,
+	btr_pcur_t*	pcur,
+	mtr_t* mtr)
 {
 	ut_ad(mode == BTR_MODIFY_LEAF
 	      || BTR_LATCH_MODE_WITHOUT_INTENTION(mode) == BTR_MODIFY_TREE);
@@ -4286,17 +4287,15 @@ ibuf_restore_pos(
 
 		return(TRUE);
 	}
-
-	if (fil_space_get_flags(space) == ULINT_UNDEFINED ||
-		fil_space_is_being_truncated(space)) {
-		/* The tablespace has been dropped. Or the tablespace is being
-		truncated. It is possible that another thread has deleted
-		the insert buffer entry.  Do not complain. */
+	fil_space_t* space = fil_space_acquire_silent(space_id);
+	if (space == NULL) {
+		/* The tablespace has been(or being) deleted. Do not complain. */
 		ibuf_btr_pcur_commit_specify_mtr(pcur, mtr);
 	} else {
+		fil_space_release(space);
 		ib::error() << "ibuf cursor restoration fails!."
 			" ibuf record inserted to page "
-			<< space << ":" << page_no;
+			<< space_id << ":" << page_no;
 
 		ib::error() << BUG_REPORT_MSG;
 

